com.amazonaws.services.lambda

## Class AWSLambdaClient

- java.lang.Object
- - com.amazonaws.AmazonWebServiceClient
  - - com.amazonaws.services.lambda.AWSLambdaClient

All Implemented Interfaces:
  AWSLambda

Direct Known Subclasses:
  AWSLambdaAsyncClient

    @ThreadSafe
    public class AWSLambdaClient
    extends AmazonWebServiceClient
    implements AWSLambda

Client for accessing AWS Lambda. All service calls made using this client are blocking, and will not return until the service call completes.

<fullname>AWS Lambda</fullname>

Overview

This is the AWS Lambda API Reference. The AWS Lambda Developer Guide provides additional information. For the service overview, go to What is AWS Lambda, and for information about how the service works, go to AWS Lambda: How it Works in the AWS Lambda Developer Guide.

### Field Summary

Fields
`protected static ClientConfigurationFactory` `configFactory` Client configuration factory providing ClientConfigurations tailored to this client

### Fields inherited from class com.amazonaws.AmazonWebServiceClient

`client, clientConfiguration, endpoint, LOGGING_AWS_REQUEST_METRIC, requestHandler2s, timeOffset`

### Fields inherited from interface com.amazonaws.services.lambda.AWSLambda

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
Constructor and Description
`AWSLambdaClient()` Constructs a new client to invoke service methods on AWS Lambda.
`AWSLambdaClient(AWSCredentials awsCredentials)` Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials.
`AWSLambdaClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials and client configuration options.
`AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider)` Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider.
`AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider and client configuration options.
`AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration, RequestMetricCollector requestMetricCollector)` Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider, client configuration options, and request metric collector.
`AWSLambdaClient(ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on AWS Lambda.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`AddPermissionResult` `addPermission(AddPermissionRequest addPermissionRequest)` Adds a permission to the resource policy associated with the specified AWS Lambda function.
`CreateAliasResult` `createAlias(CreateAliasRequest createAliasRequest)` Creates an alias that points to the specified Lambda function version.
`CreateEventSourceMappingResult` `createEventSourceMapping(CreateEventSourceMappingRequest createEventSourceMappingRequest)` Identifies a stream as an event source for a Lambda function.
`CreateFunctionResult` `createFunction(CreateFunctionRequest createFunctionRequest)` Creates a new Lambda function.
`DeleteAliasResult` `deleteAlias(DeleteAliasRequest deleteAliasRequest)` Deletes the specified Lambda function alias.
`DeleteEventSourceMappingResult` `deleteEventSourceMapping(DeleteEventSourceMappingRequest deleteEventSourceMappingRequest)` Removes an event source mapping.
`DeleteFunctionResult` `deleteFunction(DeleteFunctionRequest deleteFunctionRequest)` Deletes the specified Lambda function code and configuration.
`GetAccountSettingsResult` `getAccountSettings(GetAccountSettingsRequest getAccountSettingsRequest)` Returns a customer's account settings.
`GetAliasResult` `getAlias(GetAliasRequest getAliasRequest)` Returns the specified alias information such as the alias ARN, description, and function version it is pointing to.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected.
`GetEventSourceMappingResult` `getEventSourceMapping(GetEventSourceMappingRequest getEventSourceMappingRequest)` Returns configuration information for the specified event source mapping (see CreateEventSourceMapping).
`GetFunctionResult` `getFunction(GetFunctionRequest getFunctionRequest)` Returns the configuration information of the Lambda function and a presigned URL link to the .zip file you uploaded with CreateFunction so you can download the .zip file.
`GetFunctionConfigurationResult` `getFunctionConfiguration(GetFunctionConfigurationRequest getFunctionConfigurationRequest)` Returns the configuration information of the Lambda function.
`GetPolicyResult` `getPolicy(GetPolicyRequest getPolicyRequest)` Returns the resource policy associated with the specified Lambda function.
`InvokeResult` `invoke(InvokeRequest invokeRequest)` Invokes a specific Lambda function.
`InvokeAsyncResult` `invokeAsync(InvokeAsyncRequest invokeAsyncRequest)` Deprecated.
`ListAliasesResult` `listAliases(ListAliasesRequest listAliasesRequest)` Returns list of aliases created for a Lambda function.
`ListEventSourceMappingsResult` `listEventSourceMappings()` Simplified method form for invoking the ListEventSourceMappings operation.
`ListEventSourceMappingsResult` `listEventSourceMappings(ListEventSourceMappingsRequest listEventSourceMappingsRequest)` Returns a list of event source mappings you created using the `CreateEventSourceMapping` (see CreateEventSourceMapping).
`ListFunctionsResult` `listFunctions()` Simplified method form for invoking the ListFunctions operation.
`ListFunctionsResult` `listFunctions(ListFunctionsRequest listFunctionsRequest)` Returns a list of your Lambda functions.
`ListVersionsByFunctionResult` `listVersionsByFunction(ListVersionsByFunctionRequest listVersionsByFunctionRequest)` List all versions of a function.
`PublishVersionResult` `publishVersion(PublishVersionRequest publishVersionRequest)` Publishes a version of your function from the current snapshot of $LATEST.
`RemovePermissionResult` `removePermission(RemovePermissionRequest removePermissionRequest)` You can remove individual permissions from an resource policy associated with a Lambda function by providing a statement ID that you provided when you added the permission.
`UpdateAliasResult` `updateAlias(UpdateAliasRequest updateAliasRequest)` Using this API you can update the function version to which the alias points and the alias description.
`UpdateEventSourceMappingResult` `updateEventSourceMapping(UpdateEventSourceMappingRequest updateEventSourceMappingRequest)` You can update an event source mapping.
`UpdateFunctionCodeResult` `updateFunctionCode(UpdateFunctionCodeRequest updateFunctionCodeRequest)` Updates the code for the specified Lambda function.
`UpdateFunctionConfigurationResult` `updateFunctionConfiguration(UpdateFunctionConfigurationRequest updateFunctionConfigurationRequest)` Updates the configuration parameters for the specified Lambda function by using the values provided in the request.

### Methods inherited from class com.amazonaws.AmazonWebServiceClient

`addRequestHandler, addRequestHandler, beforeMarshalling, calculateCRC32FromCompressedData, checkMutability, configureRegion, createExecutionContext, createExecutionContext, createExecutionContext, createSignerProvider, endClientExecution, endClientExecution, getEndpointPrefix, getRequestMetricsCollector, getServiceAbbreviation, getServiceName, getServiceNameIntern, getSigner, getSignerByURI, getSignerProvider, getSignerRegionOverride, getTimeOffset, isProfilingEnabled, isRequestMetricsEnabled, makeImmutable, removeRequestHandler, removeRequestHandler, requestMetricCollector, setEndpoint, setEndpointPrefix, setRegion, setServiceNameIntern, setSignerRegionOverride, setTimeOffset, shutdown, useStrictHostNameVerification, withEndpoint, withRegion, withRegion, withTimeOffset`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.amazonaws.services.lambda.AWSLambda

`setEndpoint, setRegion, shutdown`

### Field Detail

#### configFactory

    protected static final ClientConfigurationFactory configFactory

Client configuration factory providing ClientConfigurations tailored to this client

### Constructor Detail

#### AWSLambdaClient

    public AWSLambdaClient()

Constructs a new client to invoke service methods on AWS Lambda. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

See Also:
  `DefaultAWSCredentialsProviderChain`

#### AWSLambdaClient

    public AWSLambdaClient(ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on AWS Lambda. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `clientConfiguration` - The client configuration options controlling how this client connects to AWS Lambda (ex: proxy settings, retry counts, etc.).
See Also:
  `DefaultAWSCredentialsProviderChain`

#### AWSLambdaClient

    public AWSLambdaClient(AWSCredentials awsCredentials)

Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

#### AWSLambdaClient

    public AWSLambdaClient(AWSCredentials awsCredentials,
                           ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to AWS Lambda (ex: proxy settings, retry counts, etc.).

#### AWSLambdaClient

    public AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider)

Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.

#### AWSLambdaClient

    public AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider,
                           ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to AWS Lambda (ex: proxy settings, retry counts, etc.).

#### AWSLambdaClient

    public AWSLambdaClient(AWSCredentialsProvider awsCredentialsProvider,
                           ClientConfiguration clientConfiguration,
                           RequestMetricCollector requestMetricCollector)

Constructs a new client to invoke service methods on AWS Lambda using the specified AWS account credentials provider, client configuration options, and request metric collector.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to AWS Lambda (ex: proxy settings, retry counts, etc.).
  `requestMetricCollector` - optional request metric collector

### Method Detail

#### addPermission

    public AddPermissionResult addPermission(AddPermissionRequest addPermissionRequest)

Adds a permission to the resource policy associated with the specified AWS Lambda function. You use resource policies to grant permissions to event sources that use push model. In a push model, event sources (such as Amazon S3 and custom applications) invoke your Lambda function. Each permission you add to the resource policy allows an event source, permission to invoke the Lambda function.

For information about the push model, see AWS Lambda: How it Works.

If you are using versioning, the permissions you add are specific to the Lambda function version or alias you specify in the `AddPermission` request via the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:AddPermission` action.

Specified by:
  `addPermission` in interface `AWSLambda`
Parameters:
  `addPermissionRequest` -
Returns:
  Result of the AddPermission operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `ResourceConflictException` - The resource already exists.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `PolicyLengthExceededException` - Lambda function access policy is limited to 20 KB.
  `TooManyRequestsException`

#### createAlias

    public CreateAliasResult createAlias(CreateAliasRequest createAliasRequest)

Creates an alias that points to the specified Lambda function version. For more information, see Introduction to AWS Lambda Aliases.

Alias names are unique for a given function. This requires permission for the lambda:CreateAlias action.

Specified by:
  `createAlias` in interface `AWSLambda`
Parameters:
  `createAliasRequest` -
Returns:
  Result of the CreateAlias operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `ResourceConflictException` - The resource already exists.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### createEventSourceMapping

    public CreateEventSourceMappingResult createEventSourceMapping(CreateEventSourceMappingRequest createEventSourceMappingRequest)

Identifies a stream as an event source for a Lambda function. It can be either an Amazon Kinesis stream or an Amazon DynamoDB stream. AWS Lambda invokes the specified function when records are posted to the stream.

This association between a stream source and a Lambda function is called the event source mapping.

<important>

This event source mapping is relevant only in the AWS Lambda pull model, where AWS Lambda invokes the function. For more information, go to AWS Lambda: How it Works in the AWS Lambda Developer Guide.

</important>

You provide mapping information (for example, which stream to read from and which Lambda function to invoke) in the request body.

Each event source, such as an Amazon Kinesis or a DynamoDB stream, can be associated with multiple AWS Lambda function. A given Lambda function can be associated with multiple AWS event sources.

If you are using versioning, you can specify a specific function version or an alias via the function name parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:CreateEventSourceMapping` action.

Specified by:
  `createEventSourceMapping` in interface `AWSLambda`
Parameters:
  `createEventSourceMappingRequest` -
Returns:
  Result of the CreateEventSourceMapping operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `ResourceConflictException` - The resource already exists.
  `TooManyRequestsException`
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.

#### createFunction

    public CreateFunctionResult createFunction(CreateFunctionRequest createFunctionRequest)

Creates a new Lambda function. The function metadata is created from the request parameters, and the code for the function is provided by a .zip file in the request body. If the function name already exists, the operation will fail. Note that the function name is case-sensitive.

If you are using versioning, you can also publish a version of the Lambda function you are creating using the `Publish` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:CreateFunction` action.

Specified by:
  `createFunction` in interface `AWSLambda`
Parameters:
  `createFunctionRequest` -
Returns:
  Result of the CreateFunction operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `ResourceConflictException` - The resource already exists.
  `TooManyRequestsException`
  `CodeStorageExceededException` - You have exceeded your maximum total code size per account. Limits

#### deleteAlias

    public DeleteAliasResult deleteAlias(DeleteAliasRequest deleteAliasRequest)

Deletes the specified Lambda function alias. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:DeleteAlias action.

Specified by:
  `deleteAlias` in interface `AWSLambda`
Parameters:
  `deleteAliasRequest` -
Returns:
  Result of the DeleteAlias operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### deleteEventSourceMapping

    public DeleteEventSourceMappingResult deleteEventSourceMapping(DeleteEventSourceMappingRequest deleteEventSourceMappingRequest)

Removes an event source mapping. This means AWS Lambda will no longer invoke the function for events in the associated source.

This operation requires permission for the `lambda:DeleteEventSourceMapping` action.

Specified by:
  `deleteEventSourceMapping` in interface `AWSLambda`
Parameters:
  `deleteEventSourceMappingRequest` -
Returns:
  Result of the DeleteEventSourceMapping operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### deleteFunction

    public DeleteFunctionResult deleteFunction(DeleteFunctionRequest deleteFunctionRequest)

Deletes the specified Lambda function code and configuration.

If you are using the versioning feature and you don't specify a function version in your `DeleteFunction` request, AWS Lambda will delete the function, including all its versions, and any aliases pointing to the function versions. To delete a specific function version, you must provide the function version via the `Qualifier` parameter. For information about function versioning, see AWS Lambda Function Versioning and Aliases.

When you delete a function the associated resource policy is also deleted. You will need to delete the event source mappings explicitly.

This operation requires permission for the `lambda:DeleteFunction` action.

Specified by:
  `deleteFunction` in interface `AWSLambda`
Parameters:
  `deleteFunctionRequest` -
Returns:
  Result of the DeleteFunction operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `TooManyRequestsException`
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `ResourceConflictException` - The resource already exists.

#### getAccountSettings

    public GetAccountSettingsResult getAccountSettings(GetAccountSettingsRequest getAccountSettingsRequest)

Returns a customer's account settings.

You can use this operation to retrieve Lambda limit information such as code size and concurrency limits. For more information on limits, see AWS Lambda Limits. You can also retrieve resource usage statistics such as code storage usage and function count.

Specified by:
  `getAccountSettings` in interface `AWSLambda`
Parameters:
  `getAccountSettingsRequest` -
Returns:
  Result of the GetAccountSettings operation returned by the service.
Throws:
  `TooManyRequestsException`
  `ServiceException` - The AWS Lambda service encountered an internal error.

#### getAlias

    public GetAliasResult getAlias(GetAliasRequest getAliasRequest)

Returns the specified alias information such as the alias ARN, description, and function version it is pointing to. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the `lambda:GetAlias` action.

Specified by:
  `getAlias` in interface `AWSLambda`
Parameters:
  `getAliasRequest` -
Returns:
  Result of the GetAlias operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### getEventSourceMapping

    public GetEventSourceMappingResult getEventSourceMapping(GetEventSourceMappingRequest getEventSourceMappingRequest)

Returns configuration information for the specified event source mapping (see CreateEventSourceMapping).

This operation requires permission for the `lambda:GetEventSourceMapping` action.

Specified by:
  `getEventSourceMapping` in interface `AWSLambda`
Parameters:
  `getEventSourceMappingRequest` -
Returns:
  Result of the GetEventSourceMapping operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### getFunction

    public GetFunctionResult getFunction(GetFunctionRequest getFunctionRequest)

Returns the configuration information of the Lambda function and a presigned URL link to the .zip file you uploaded with CreateFunction so you can download the .zip file. Note that the URL is valid for up to 10 minutes. The configuration information is the same information you provided as parameters when uploading the function.

Using the optional `Qualifier` parameter, you can specify a specific function version for which you want this information. If you don't specify this parameter, the API uses unqualified function ARN which return information about the `$LATEST` version of the Lambda function. For more information, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:GetFunction` action.

Specified by:
  `getFunction` in interface `AWSLambda`
Parameters:
  `getFunctionRequest` -
Returns:
  Result of the GetFunction operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `TooManyRequestsException`
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.

#### getFunctionConfiguration

    public GetFunctionConfigurationResult getFunctionConfiguration(GetFunctionConfigurationRequest getFunctionConfigurationRequest)

Returns the configuration information of the Lambda function. This the same information you provided as parameters when uploading the function by using CreateFunction.

If you are using the versioning feature, you can retrieve this information for a specific function version by using the optional `Qualifier` parameter and specifying the function version or alias that points to it. If you don't provide it, the API returns information about the $LATEST version of the function. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:GetFunctionConfiguration` operation.

Specified by:
  `getFunctionConfiguration` in interface `AWSLambda`
Parameters:
  `getFunctionConfigurationRequest` -
Returns:
  Result of the GetFunctionConfiguration operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `TooManyRequestsException`
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.

#### getPolicy

    public GetPolicyResult getPolicy(GetPolicyRequest getPolicyRequest)

Returns the resource policy associated with the specified Lambda function.

If you are using the versioning feature, you can get the resource policy associated with the specific Lambda function version or alias by specifying the version or alias name using the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

For information about adding permissions, see AddPermission.

You need permission for the `lambda:GetPolicy action.`

Specified by:
  `getPolicy` in interface `AWSLambda`
Parameters:
  `getPolicyRequest` -
Returns:
  Result of the GetPolicy operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `TooManyRequestsException`
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.

#### invoke

    public InvokeResult invoke(InvokeRequest invokeRequest)

Invokes a specific Lambda function. For an example, see Create the Lambda Function and Test It Manually.

If you are using the versioning feature, you can invoke the specific function version by providing function version or alias name that is pointing to the function version using the `Qualifier` parameter in the request. If you don't provide the `Qualifier` parameter, the `$LATEST` version of the Lambda function is invoked. Invocations occur at least once in response to an event and functions must be idempotent to handle this. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:InvokeFunction` action.

Specified by:
  `invoke` in interface `AWSLambda`
Parameters:
  `invokeRequest` -
Returns:
  Result of the Invoke operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidRequestContentException` - The request body could not be parsed as JSON.
  `RequestTooLargeException` - The request payload exceeded the `Invoke` request body JSON input limit. For more information, see Limits.
  `UnsupportedMediaTypeException` - The content type of the `Invoke` request body is not JSON.
  `TooManyRequestsException`
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `EC2UnexpectedException` - AWS Lambda received an unexpected EC2 client exception while setting up for the Lambda function.
  `SubnetIPAddressLimitReachedException` - AWS Lambda was not able to set up VPC access for the Lambda function because one or more configured subnets has no available IP addresses.
  `ENILimitReachedException` - AWS Lambda was not able to create an Elastic Network Interface (ENI) in the VPC, specified as part of Lambda function configuration, because the limit for network interfaces has been reached.
  `EC2ThrottledException` - AWS Lambda was throttled by Amazon EC2 during Lambda function initialization using the execution role provided for the Lambda function.
  `EC2AccessDeniedException`
  `InvalidSubnetIDException` - The Subnet ID provided in the Lambda function VPC configuration is invalid.
  `InvalidSecurityGroupIDException` - The Security Group ID provided in the Lambda function VPC configuration is invalid.
  `InvalidZipFileException` - AWS Lambda could not unzip the function zip file.
  `KMSDisabledException` - Lambda was unable to decrypt the environment variables because the KMS key used is disabled. Please check the Lambda function's KMS key settings.
  `KMSInvalidStateException` - Lambda was unable to decrypt the environment variables because the KMS key used is in an invalid state for Decrypt. Please check the function's KMS key settings.
  `KMSAccessDeniedException` - Lambda was unable to decrypt the environment variables because KMS access was denied. Please check the Lambda function's KMS permissions.
  `KMSNotFoundException` - Lambda was unable to decrypt the environment variables because the KMS key was not found. Please check the function's KMS key settings.

#### invokeAsync

    @Deprecated
    public InvokeAsyncResult invokeAsync(InvokeAsyncRequest invokeAsyncRequest)

Deprecated.
<important>

This API is deprecated. We recommend you use `Invoke` API (see Invoke).

</important>

Submits an invocation request to AWS Lambda. Upon receiving the request, Lambda executes the specified function asynchronously. To see the logs generated by the Lambda function execution, see the CloudWatch Logs console.

This operation requires permission for the `lambda:InvokeFunction` action.

Specified by:
  `invokeAsync` in interface `AWSLambda`
Parameters:
  `invokeAsyncRequest` -
Returns:
  Result of the InvokeAsync operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidRequestContentException` - The request body could not be parsed as JSON.

#### listAliases

    public ListAliasesResult listAliases(ListAliasesRequest listAliasesRequest)

Returns list of aliases created for a Lambda function. For each alias, the response includes information such as the alias ARN, description, alias name, and the function version to which it points. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:ListAliases action.

Specified by:
  `listAliases` in interface `AWSLambda`
Parameters:
  `listAliasesRequest` -
Returns:
  Result of the ListAliases operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### listEventSourceMappings

    public ListEventSourceMappingsResult listEventSourceMappings(ListEventSourceMappingsRequest listEventSourceMappingsRequest)

Returns a list of event source mappings you created using the `CreateEventSourceMapping` (see CreateEventSourceMapping).

For each mapping, the API returns configuration information. You can optionally specify filters to retrieve specific event source mappings.

If you are using the versioning feature, you can get list of event source mappings for a specific Lambda function version or an alias as described in the `FunctionName` parameter. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:ListEventSourceMappings` action.

Specified by:
  `listEventSourceMappings` in interface `AWSLambda`
Parameters:
  `listEventSourceMappingsRequest` -
Returns:
  Result of the ListEventSourceMappings operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### listEventSourceMappings

    public ListEventSourceMappingsResult listEventSourceMappings()

Description copied from interface: `AWSLambda`
Simplified method form for invoking the ListEventSourceMappings operation.

Specified by:
  `listEventSourceMappings` in interface `AWSLambda`
See Also:
  `AWSLambda.listEventSourceMappings(ListEventSourceMappingsRequest)`

#### listFunctions

    public ListFunctionsResult listFunctions(ListFunctionsRequest listFunctionsRequest)

Returns a list of your Lambda functions. For each function, the response includes the function configuration information. You must use GetFunction to retrieve the code for your function.

This operation requires permission for the `lambda:ListFunctions` action.

If you are using versioning feature, the response returns list of $LATEST versions of your functions. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `listFunctions` in interface `AWSLambda`
Parameters:
  `listFunctionsRequest` -
Returns:
  Result of the ListFunctions operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `TooManyRequestsException`

#### listFunctions

    public ListFunctionsResult listFunctions()

Description copied from interface: `AWSLambda`
Simplified method form for invoking the ListFunctions operation.

Specified by:
  `listFunctions` in interface `AWSLambda`
See Also:
  `AWSLambda.listFunctions(ListFunctionsRequest)`

#### listVersionsByFunction

    public ListVersionsByFunctionResult listVersionsByFunction(ListVersionsByFunctionRequest listVersionsByFunctionRequest)

List all versions of a function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `listVersionsByFunction` in interface `AWSLambda`
Parameters:
  `listVersionsByFunctionRequest` -
Returns:
  Result of the ListVersionsByFunction operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### publishVersion

    public PublishVersionResult publishVersion(PublishVersionRequest publishVersionRequest)

Publishes a version of your function from the current snapshot of $LATEST. That is, AWS Lambda takes a snapshot of the function code and configuration information from $LATEST and publishes a new version. The code and configuration cannot be modified after publication. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `publishVersion` in interface `AWSLambda`
Parameters:
  `publishVersionRequest` -
Returns:
  Result of the PublishVersion operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`
  `CodeStorageExceededException` - You have exceeded your maximum total code size per account. Limits

#### removePermission

    public RemovePermissionResult removePermission(RemovePermissionRequest removePermissionRequest)

You can remove individual permissions from an resource policy associated with a Lambda function by providing a statement ID that you provided when you added the permission.

If you are using versioning, the permissions you remove are specific to the Lambda function version or alias you specify in the `AddPermission` request via the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

Note that removal of a permission will cause an active event source to lose permission to the function.

You need permission for the `lambda:RemovePermission` action.

Specified by:
  `removePermission` in interface `AWSLambda`
Parameters:
  `removePermissionRequest` -
Returns:
  Result of the RemovePermission operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### updateAlias

    public UpdateAliasResult updateAlias(UpdateAliasRequest updateAliasRequest)

Using this API you can update the function version to which the alias points and the alias description. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:UpdateAlias action.

Specified by:
  `updateAlias` in interface `AWSLambda`
Parameters:
  `updateAliasRequest` -
Returns:
  Result of the UpdateAlias operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### updateEventSourceMapping

    public UpdateEventSourceMappingResult updateEventSourceMapping(UpdateEventSourceMappingRequest updateEventSourceMappingRequest)

You can update an event source mapping. This is useful if you want to change the parameters of the existing mapping without losing your position in the stream. You can change which function will receive the stream records, but to change the stream itself, you must create a new mapping.

If you are using the versioning feature, you can update the event source mapping to map to a specific Lambda function version or alias as described in the `FunctionName` parameter. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

If you disable the event source mapping, AWS Lambda stops polling. If you enable again, it will resume polling from the time it had stopped polling, so you don't lose processing of any records. However, if you delete event source mapping and create it again, it will reset.

This operation requires permission for the `lambda:UpdateEventSourceMapping` action.

Specified by:
  `updateEventSourceMapping` in interface `AWSLambda`
Parameters:
  `updateEventSourceMappingRequest` -
Returns:
  Result of the UpdateEventSourceMapping operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`
  `ResourceConflictException` - The resource already exists.

#### updateFunctionCode

    public UpdateFunctionCodeResult updateFunctionCode(UpdateFunctionCodeRequest updateFunctionCodeRequest)

Updates the code for the specified Lambda function. This operation must only be used on an existing Lambda function and cannot be used to update the function configuration.

If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:UpdateFunctionCode` action.

Specified by:
  `updateFunctionCode` in interface `AWSLambda`
Parameters:
  `updateFunctionCodeRequest` -
Returns:
  Result of the UpdateFunctionCode operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`
  `CodeStorageExceededException` - You have exceeded your maximum total code size per account. Limits

#### updateFunctionConfiguration

    public UpdateFunctionConfigurationResult updateFunctionConfiguration(UpdateFunctionConfigurationRequest updateFunctionConfigurationRequest)

Updates the configuration parameters for the specified Lambda function by using the values provided in the request. You provide only the parameters you want to change. This operation must only be used on an existing Lambda function and cannot be used to update the function's code.

If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:UpdateFunctionConfiguration` action.

Specified by:
  `updateFunctionConfiguration` in interface `AWSLambda`
Parameters:
  `updateFunctionConfigurationRequest` -
Returns:
  Result of the UpdateFunctionConfiguration operation returned by the service.
Throws:
  `ServiceException` - The AWS Lambda service encountered an internal error.
  `ResourceNotFoundException` - The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.
  `InvalidParameterValueException` - One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the `CreateFunction` or the `UpdateFunctionConfiguration` API, that AWS Lambda is unable to assume you will get this exception.
  `TooManyRequestsException`

#### getCachedResponseMetadata

    public ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing the request.

Specified by:
  `getCachedResponseMetadata` in interface `AWSLambda`
Parameters:
  `request` - The originally executed request
Returns:
  The response metadata for the specified request, or null if none is available.